import java.awt.Color;
import java.awt.Graphics;

public class ball {

	private double wind = 0;
	private double angle = 0;
	public double magnitude = 0;
	private double xPos = 200;
	private double yPos = 200;
	private double xPosNew = 0;
	private double yPosNew = 0;
	private double xAcc, yAcc = 0;
	private double xVel, yVel = 0;
	private double angularVel = 800;
	
	boolean drawVectors = false;
	boolean rolling = false;
	double a,b,c,d,e,f,h;
	double count = 0;



	static Graphics g;
	static int width;
	static int height;
	double[] Ground;
	FVector[] vectors;
	private final double timeStep = 0.05;
	private final double airDensity = 1.225;
	private final double radius = 0.05;
	private final double gForce = 9;
	private final double diameter = 0.1;
	private final double gDrag = 15;
	private final double cDrag = 0.15;

	public void update(){
		
		rolling = true;
		double angleAt = angleAt(xPos,yPos);

		//add all force vectors to the array
		vectors = new FVector[10];
		int i = 0;


		//gravity
		vectors[i] = new FVector(gForce, -90, Color.black);
		//bounce
		if(bounce()){


			i++;
			if(true){
				vectors[i] = new FVector( (magnitude * Math.abs(Math.pow(Math.sin(Math.toRadians(angle + angleAt)), 2))) * 1 ,(angleAt + 90), Color.green);
			}

		

			i++; //g1
			vectors[i] = new FVector(Math.abs(Math.sin(Math.toRadians(angleAt)) * gForce),angleAt + 90  , Color.MAGENTA);

			i++; //g2
			vectors[i] = new FVector(Math.cos(Math.toRadians(angleAt)) * gForce, 90, Color.blue);


			angle = -angle + angleAt + angleAt;
			
			i++;
			vectors[i] = new FVector( magnitude * cDrag * airDensity * gDrag + (gForce * Math.abs(Math.sin(Math.toRadians(angleAt)))) , angle + 180, Color.red);
		}else {
			rolling = false;
			i++;
			vectors[i] = new FVector( magnitude * cDrag * airDensity , angle + 180, Color.red);
		}
		

		//wind
		i++;
		vectors[i] = new FVector(wind, 0, Color.yellow);
		//lift
		i++;
		vectors[i] = new FVector( (airDensity * magnitude * radius * 4 * angularVel * Math.pow(diameter, 2)) * (2 * radius), angle + 90, Color.GRAY);



		xAcc = 0;
		yAcc = 0;
		//update acceleration
		for(FVector v: vectors){
			if(v != null){
				xAcc += Math.cos(Math.toRadians(v.theta)) * v.r;
				yAcc += Math.sin(Math.toRadians(v.theta)) * v.r;
			}
		}

		xVel = Math.cos(Math.toRadians(angle)) * magnitude;
		yVel = Math.sin(Math.toRadians(angle)) * magnitude;

		//update velocity
		xVel = xVel + (xAcc * timeStep);
		yVel = yVel + (yAcc * timeStep);

		//update position
		xPosNew = xPos + (xVel * timeStep + 0.5 * xAcc * Math.pow(timeStep,2));
		yPosNew = yPos + (yVel * timeStep + 0.5 * yAcc * Math.pow(timeStep,2));


		xPos = xPosNew;
		yPos = yPosNew;

		if(xVel < 0 && yVel < 0){
			angle = Math.toDegrees(Math.atan(yVel / xVel)) - 180;
		} else if(xVel < 0 && yVel > 0){
			angle = Math.toDegrees(Math.atan(yVel / xVel)) + 180;
		} else{
			angle = Math.toDegrees(Math.atan(yVel / xVel));
		}

		magnitude = Math.sqrt(Math.pow(xVel, 2) + Math.pow(yVel, 2));
		
		
		decAngularVel();

	}

	private boolean bounce(){



		if(this.yPos <= getY(this.xPos)){
			return true;
		}else{
			return false;
		}

	}

	//decriment angular velocity at a rate of 3% per second
	private void decAngularVel(){
		angularVel = angularVel * Math.pow(Math.E,-timeStep * 0.3);
		
		
	}
	
	public void show(){
		g.setColor(Color.BLACK);
		g.drawOval((int) xPos - 2, (int)(height - yPos - 2), 4, 4);


		//draw lines representing force vectors
		for(FVector v: vectors){
			if(v != null && drawVectors){
				g.setColor(v.c);
				g.drawLine((int) xPos,(int) (height - yPos), (int) (xPos + (10 * v.x)), (int) (height - (yPos + (10 * v.y))));
				
			}
		}
		
	}

	

	public void drawGround(){
		this.setGround();
		g.setColor(Color.green);
		for(int i = 0; i < Ground.length - 1;i++){
			g.drawLine((int) i, (int)(height - Ground[i]), (int) i + 1, (int)(height - Ground[i + 1]));

		}
	}
	/**
	 * Creates a global double[] that contains the y values for index at the x position.
	 */
	public void setGround(){
		Ground = new double[width];
		for(int i = 0; i < Ground.length; i ++){
			Ground[i] = getY(i);
			

		}
	}

	public static void clearBackground(){
		
		g.clearRect(0, 0, width, height);
	}
	/**
	 * returns the angle of the ground in degrees at a given (x,y) position
	 * @param x
	 * @param y
	 * @return
	 */
	private double angleAt(double x, double y) {
		double x1,y1,x2,y2;

		x1 = x - 0.01;
		x2 = x + 0.01;

		double angle = 0;

		//find the pont ahead
		y1 = getY(x1);

		//find the point behind
		y2 = getY(x2);


		//find angle
		angle = Math.toDegrees(Math.atan((y2 - y1)/(x2 - x1 )));



		return angle;



	}
	/**
	 * returns the value of y at a given x position
	 * @param x
	 * @return
	 */
	private double getY(double x){

		double y;
		a = 0;
		b = 0;
		c = 0.00000005259;
		d = -0.000071338;
		e = 0.032609;
		f = -5.6706;
		h = 400;


		if(x > 400){
			y = 1.0 / 5.0 * x + 75 + Math.sin(Math.toDegrees(0.005 * x));
		}else{
			y = 50 * Math.sin(Math.toDegrees(0.005 * x)) + 100;
		}
		//y = Math.abs(x - width/2);
		//y = 100;
		
		//y =a * Math.pow(x,6) + b * Math.pow(x,5)+ c * Math.pow(x,4) + d * Math.pow(x , 3) + e * Math.pow(x,2 ) + f * x + h + 20 * (Math.sin(Math.toDegrees(count + x * 0.005)))  ;
		return y;

	}

	public void addHit(double power, double angle){

		this.magnitude = power;
		this.angle = angle;


	}
	/**
	 * Set the (x,y) position of the ball, velocity is unchanged in magnitude or direction.
	 * @param x
	 * @param y
	 */
	public void setPos(double x, double y){
		this.xPos = x;
		this.yPos = height - y;
	}
	
	/**
	 * Constructor function
	 * @param x
	 * @param y position that the ball should start out at
	 * @param g
	 * @param width of the canvas
	 * @param height of the canvas
	 */
	public ball(double x, double y, Graphics g, int width, int height){
		xPos = x;
		yPos = y;
		this.g = g;
		this.width = width;
		this.height = height;

	}

}


